<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 会员出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯会员隐
//       私信息的前提下，保留以任何方式获取会员信息及商品信息的权利；
//
//   有关本产品最终会员授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权会员生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace App\Api;

use App\Common\Api;
use Base\Domain\User as UserDomain;
use Base\Domain\UserType as UserTypeDomain;
use PhalApi\Exception\BadRequestException;
use Base\Domain\Login;
use Base\Common\ToolUtil;

/**
 * 会员模块
 */
class User extends Api {
    public function getRules() {
        $memberTypeDesc = UserTypeDomain::getApiRuleRangeDescForMember();

        return array(
            'register' => array(
                'username' => array('name' => 'username', 'require' => true, 'min' => 1, 'max' => 50, 'desc' => '账号'),
                'password' => array('name' => 'password', 'require' => true, 'min' => 6, 'max' => 20, 'desc' => '密码'),
                'avatar' => array('name' => 'avatar', 'default' => '', 'max' => 500, 'desc' => '头像链接'),
                'nickname' => array('name' => 'nickname', 'default' => '', 'max' => 100, 'desc' => '昵称'),
                'email' => array('name' => 'email', 'default' => '', 'max' => 100, 'desc' => '邮箱'),
                'sex' => array('name' => 'sex', 'default' => '0', 'desc' => '性别，0未知1男2女'),
                'mobile' => array('name' => 'mobile', 'default' => '', 'max' => 20, 'desc' => '手机号'),
                'memberType' => array('name' => 'member_type', 'type' => 'int', 'default' => 0, 'desc' => '账号类型。' . $memberTypeDesc),
            ),
            'alterPass' => array(
                'password' => array('name' => 'password', 'require' => true, 'min' => 6, 'max' => 20, 'desc' => '旧密码'),
                'newPassword' => array('name' => 'new_password', 'require' => true, 'min' => 6, 'max' => 20, 'desc' => '新密码'),
            ),
            'userProfile' => array(
                'username' => array('name' => 'username', 'require' => true, 'min' => 1, 'max' => 50, 'desc' => '账号'),
            ),
            'updateProfile' => array(
                'avatar' => array('name' => 'avatar', 'max' => 500, 'desc' => '头像链接，不传时不更新'),
                'nickname' => array('name' => 'nickname', 'max' => 100, 'desc' => '昵称，不传时不更新'),
                'email' => array('name' => 'email', 'max' => 100, 'desc' => '邮箱，不传时不更新'),
                'sex' => array('name' => 'sex', 'desc' => '性别，0未知1男2女，不传时不更新'),
                'mobile' => array('name' => 'mobile', 'max' => 20, 'desc' => '手机号，不传时不更新'),
            ),
            'userLogin' => array(
                'username' => array('name' => 'username', 'require' => true, 'min' => 1, 'max' => 50, 'desc' => '登录账号'),
                'password' => array('name' => 'password', 'require' => true, 'min' => 6, 'max' => 20, 'desc' => '登录密码'),
            ),
        );
    }

    /**
     * 会员注册接口
     * @desc 根据账号和密码进行普通会员注册
     * @return boolean is_register 是否注册成功，true注册成功，false注册失败，账号已存在
     * @return int uid 注册成功后的会员ID，失败时为0
     */
    public function register() {
        $rs = array('is_register' => false, 'uid' => 0);
        
        // 总开关
        if (!\PhalApi\DI()->config->get('app.project.is_member_register')) {
            throw new BadRequestException(\PhalApi\T("member registration is currently disabled, please contact the administrator"));
        }
        
        if (!UserTypeDomain::isAllowReigsterForMember($this->memberType)) {
            throw new BadRequestException(\PhalApi\T("the account is illegal, current account type does not allow member to register"));
        }
        
        $domain = new UserDomain();
        $profile = $domain->profile($this->username);
        if ($profile) {
            throw new BadRequestException(\PhalApi\T("the account already exists, and repeated registration is not allowed"));
        }

        $uid = $domain->register($this->username, $this->password, $this->avatar, $this->nickname, $this->email, $this->sex, $this->mobile, $this->memberType);
        if ($uid > 0) {
            $rs['is_register'] = true;
            $rs['uid'] = $uid;
        }

        return $rs;
    }

    /**
     * 修改当前会员密码
     * @desc <span class="ui orange label">会员登录</span> 根据旧密码修改当前会员的新密码，需要会员先登录。
     */
    public function alterPass() {
        $rs = array('is_alter' => false);

        $uid = $this->tryToGetUid();
        $domain = new UserDomain();
        $alterRows = $domain->alterPassByUid($uid, $this->password, $this->newPassword);
        if ($alterRows > 0) {
            $rs['is_alter'] = true;
        }

        return $rs;
    }

    /**
     * 获取我的资料
     * @desc <span class="ui orange label">会员登录</span> 获取当前登录会员自己的个人资料，更为全面的个人资料。
     * @return object profile 会员资料，不存在时为null
     * @return int profile.id 会员ID
     * @return string profile.username 账号
     * @return string profile.register_time 注册时间，例如：2019-12-19 17:03:45
     * @return string profile.avatar 头像链接
     * @return string profile.nickname 昵称
     * @return string profile.email 邮箱
     * @return string profile.sex 性别，0未知1男2女
     * @return string profile.mobile 手机号
     * @return int profile.member_level 会员等级
     * @return int profile.member_status 会员状态(0表示禁止,1表示正常)
     */
    public function profile() {
        $rs = array('profile' => null);

        $uid = $this->tryToGetUid();

        $domain = new UserDomain();
        $profile = $domain->profileByUid($uid);
        if ($profile) {
            $rs['profile'] = $profile;
        }

        return $rs;
    }

    /**
     * 获取会员资料
     * @desc 根据账号，获取指定会员的个人资料，可以获取其他会员的个人资料。
     * @return object profile 会员资料，不存在时为null
     * @return int profile.id 会员ID
     * @return string profile.username 账号
     * @return string profile.register_time 注册时间，例如：2019-12-19 17:03:45
     * @return string profile.avatar 头像链接
     * @return string profile.nickname 昵称
     * @return string profile.email 邮箱
     * @return string profile.sex 性别，0未知1男2女
     * @return string profile.mobile 手机号
     */
    public function userProfile() {
        $rs = array('profile' => null);

        $domain = new UserDomain();
        $profile = $domain->profile($this->username);
        if ($profile) {
            $rs['profile'] = $profile;
        }

        return $rs;
    }

    /**
     * 更新我的会员资料
     * @desc <span class="ui orange label">会员登录</span> 更新指定会员账号的资料
     * @return boolean is_update 是否更新成功，true更新成功，false无更新或更新失败
     * @return object profile 更新后的会员资料，不存在时为null
     */
    public function updateProfile() {
        $rs = array('is_update' => false, 'profile' => null);

        $uid = $this->tryToGetUid();

        $domain = new UserDomain();
        $updateRows = $domain->updateProfileByUid($uid, $this->avatar, $this->nickname, $this->email, $this->sex, $this->mobile, null);
        if ($updateRows > 0) {
            $rs['is_update'] = true;
        }

        $profile = $domain->profileByUid($uid);
        if ($profile) {
            $rs['profile'] = $profile;
        }

        return $rs;
    }
    
    /**
     * 会员登录接口
     * @ignore
     * @desc 根据会员的账号和密码进行开发者登录，登录成功后分配新的访问令牌。此访问令牌不仅包括app_key信息，还包含了登录会员的账号ID。
     * @return string access_token 新的访问令牌，包含登录会员信息，申请失败时返回空字符串
     * @return int expire_at 过期时间戳
     */
    public function userLogin() {
        $rs = array('access_token' => '', 'expire_at' => 0);
        
        $user = new UserDomain();
        if (!$user->userLogin($this->username, $this->password)) {
            // 禁用，账号不存在，密码错误在domain记录了
            throw new BadRequestException(\PhalApi\T("login failed, wrong account or password, or account is disabled"));
        }
        
        $profile = $user->profile($this->username);
        
        $config = \PhalApi\DI()->config;
        $key = $config->get('app.jwt.key');
        $time = time();
        $appKey = $this->tryToGetAppKey();
        
        $token = array(
            "iss" => ToolUtil::createISS($key),        // 该JWT的签发者
            "aud" => 'user',        // 接收该JWT的一方
            "sub" => $appKey,                    // 该JWT所面向的开发者
            "uid" => intval($profile['id']),
            "iat" => $time,                         // 在什么时候签发的
            "exp" => $time + $config->get('app.jwt.exp', 86400),        // 什么时候过期，这里是一个Unix时间戳
            
        );
        
        $jwt = \lmxdawn\jwt\JWT::encode($token, $key, 'HS256');
        
        // 记录登录成功
        Login::addLoginLog($this->username, Login::LOGIN_STATUS_SUCCESS);
        
        $rs['access_token'] = $jwt;
        $rs['expire_at'] = $token['exp'];
        
        return $rs;
    }
} 
